uses crt;
const n=10; m=n*n;
Type TBoard=^array[1..n,1..n] of integer;
var p:TBoard; k:integer; L:boolean;
    f:text;

Function correct(x,y,i:integer):boolean;
  begin
    case i of
      1: begin inc(x); dec(y,2) end;
      2: begin inc(x,2); dec(y) end;
      3: begin inc(x,2); inc(y) end;
      4: begin inc(x); inc(y,2) end;
      5: begin dec(x); inc(y,2) end;
      6: begin dec(x,2); inc(y) end;
      7: begin dec(x,2); dec(y) end;
      8: begin dec(x); dec(y,2) end;
    end;
    correct:=(x>0)and(y>0)and(x<=n)and(y<=n)
  end;
  
Procedure PrintBoard(p:TBoard);
  var i,j:integer;
  begin
    for i:=1 to n do
      begin
        for j:=1 to n do
          write(f,p^[i,j]:4);
        writeln(f);
      end;
  end;
  
Procedure ClearBoard(var p:TBoard);
  var i,j:integer;

  begin
    for i:=1 to n do
    for j:=1 to n do
      p^[i,j]:=0;
  end;

procedure  move(var p:TBoard;x,y:integer;var L:boolean;var k:integer);
  var i:integer;
      xn,yn,k0:integer;
      MiniL:boolean;
      q:TBoard;
  begin
    q:=p;k0:=k;
    if L
      then
        begin
          if p^[x,y]=0
            then
              p^[x,y]:=k;
          if (k>=m)
            then
              begin
                L:=true;
                printboard(p); close(f);
                halt;
              end
            else
              begin
                MiniL:=false;
                for i:=1 to 8 do
                  if correct(x,y,i)
                    then
                      begin
                        case i of
                          1: begin xn:=x+1; yn:=y-2 end;
                          2: begin xn:=x+2; yn:=y-1 end;
                          3: begin xn:=x+2; yn:=y+1 end;
                          4: begin xn:=x+1; yn:=y+2 end;
                          5: begin xn:=x-1; yn:=y+2 end;
                          6: begin xn:=x-2; yn:=y+1 end;
                          7: begin xn:=x-2; yn:=y-1 end;
                          8: begin xn:=x-1; yn:=y-2 end;
                        end;
                        if p^[xn,yn]=0
                          then
                            begin
                              inc(k);
                              move(p,xn,yn,L,k);
                              if not(L)
                                then
                                  MiniL:=true;
                            end
                      end;
                if not(MiniL)
                  then
                    begin
                      p:=q;
                      k:=k0-1;
                      p^[x,y]:=0
                    end;
              end
         end
       else
         p^[x,y]:=0;
  end;

begin
  new(p);
  ClearBoard(p);
  L:=true;
  k:=1;
  assign(f,'h:/kon.txt');
  rewrite(f);
  move(p,1,1,L,k)  
end.